<?php
/**
 * @package     ContentBuilder
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once(JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . 'com_contentbuilder' . DS . 'classes' . DS . 'contentbuilder.php');
        

class modContentbuilder_list_filterHelper
{
    function getSetup( $params )
    {
        $menu_filter_setup = array();
        $menu_filter_setup_order = array();
        
        $menu_filter = $params->get('cb_list_filterhidden', null);
        
        if($menu_filter !== null){
            $lines  = explode("\n", $menu_filter);
            foreach($lines As $line){
                $keyval = explode("\t", $line);
                if(count($keyval) == 2){
                    $keyval[1] = explode('#',str_replace( array("\n","\r"), "", $keyval[1] ));
                    $keyvalcount = count($keyval[1]);
                    for($i = 0; $i < $keyvalcount; $i++){
                        $keyval[1][$i] = contentbuilder::execPhpValue($keyval[1][$i]);
                        if($keyval[1][$i] != ''){
                            $menu_filter_setup[$keyval[0]][] = $keyval[1][$i];
                        }
                    }
                }
            }
         }
        
         $menu_filter_order = $params->get('cb_list_orderhidden', null);
        
         if($menu_filter_order !== null){
            $lines  = explode("\n", $menu_filter_order);
            foreach($lines As $line){
                $keyval = explode("\t", $line);
                if(count($keyval) == 2){
                    $keyval[1] = str_replace( array("\n","\r"), "", $keyval[1] );
                    if($keyval[1] != ''){
                        $menu_filter_setup_order[$keyval[0]] = intval($keyval[1]);
                    }
                }
            }
         }
         
         @natsort($menu_filter_setup_order);
        
         $ordered = array();
         
         foreach($menu_filter_setup_order As $order_key => $order){
            if(isset($menu_filter_setup[$order_key])){
                $ordered[$order_key] = $menu_filter_setup[$order_key];
            }                
         }
         
         return $ordered;
    }
    
    function renderFields($setup, $params){
        
        $form_id = $params->get('form_id', null);
        if(!$form_id) return array();
        
        $fields = array();
        
        foreach($setup As $col => $rows){
            
            $has_options = false;
            
            $fields[$col]['calendars'] = '';
            $fields[$col]['selects'] = '<div class="cbListFilterSelectWrapper"><select name="cb_filter['.$col.']" class="inputbox cbListFilterSelect chzn-done"><option value=""> - '.JText::_('COM_CONTENTBUILDER_CHOOSE').' - </option>';
            
            foreach($rows As $row){
                switch($row){
                    
                    case stripos($row, '@range/calendar/from-to') === 0:
                    case stripos($row, '@range/calendar/from') === 0:
                    case stripos($row, '@range/calendar/to') === 0:
                        
                        $session_calendar_filter_from = JFactory::getSession()->get('com_contentbuilder.calendar_filter_from.'.$form_id, array());
                        $session_calendar_filter_to = JFactory::getSession()->get('com_contentbuilder.calendar_filter_to.'.$form_id, array());
                        $session_calendar_formats = JFactory::getSession()->get('com_contentbuilder.calendar_formats.'.$form_id, array());
                        
                        JHTML::_('behavior.calendar');
                        $cal = '';
                        
                        $tokens = explode('/',$row);
                        
                        $format = '%Y-%m-%d';
                        $value = '';
                        
                        if(count($tokens) == 4){
                           $format = $tokens[3];
                        }
                        else if(isset($session_calendar_formats[$col])){
                            $format = $session_calendar_formats[$col];
                        }
                        
                        $default_value_from = '';
                        if(isset($session_calendar_filter_from[$col])){
                            $default_value_from = $session_calendar_filter_from[$col];
                        }
                        
                        $default_value_to = '';
                        if(isset($session_calendar_filter_to[$col])){
                            $default_value_to = $session_calendar_filter_to[$col];
                        }
                        
                        if(stripos($row, '@range/calendar/from-to') === 0){
                            $cal .= '<div class="cbListFilterCalendarWrapper">';
                            $cal .= '<input class="inputbox cbListFilterCalendar" id="cbListFilterCalendarFrom_'.$col.'" name="cbListFilterCalendarFrom['.$col.']" type="text" value="'.htmlentities($default_value_from, ENT_QUOTES, 'UTF-8').'"/>';
                            $cal .= '<button id="cbListFilterCalendarFrom_'.$col.'_button" class="button cbListFilterCalendarButton">'.JText::_('COM_CONTENTBUILDER_FROM').'</button>';
                            $cal .= '</div>';
                            $cal .= '<div class="cbListFilterCalendarWrapper">';
                            $cal .= '<input class="inputbox cbListFilterCalendar" id="cbListFilterCalendarTo_'.$col.'" name="cbListFilterCalendarTo['.$col.']" type="text" value="'.htmlentities($default_value_to, ENT_QUOTES, 'UTF-8').'"/>';
                            $cal .= '<button id="cbListFilterCalendarTo_'.$col.'_button" class="button cbListFilterCalendarButton">'.JText::_('COM_CONTENTBUILDER_TO').'</button>';
                            $cal .= '</div>';
                            $cal .= '<script type="text/javascript">
                            <!--
                            Calendar.setup({
                                    inputField     :    "cbListFilterCalendarFrom_'.$col.'",
                                    button         :    "cbListFilterCalendarFrom_'.$col.'_button",
                                    ifFormat       :    "'.$format.'",
                                    align          :    "Bl",
                                    singleClick    :    true
                            });
                            //-->
                            </script>';
                            $cal .= '<script type="text/javascript">
                            <!--
                            Calendar.setup({
                                    inputField     :    "cbListFilterCalendarTo_'.$col.'",
                                    button         :    "cbListFilterCalendarTo_'.$col.'_button",
                                    ifFormat       :    "'.$format.'",
                                    align          :    "Bl",
                                    singleClick    :    true
                            });
                            contentbuilder_calendar_fields.push({from: "cbListFilterCalendarFrom_'.$col.'", to: "cbListFilterCalendarTo_'.$col.'", col: "'.$col.'"});
                            //-->
                            </script>';
                            $cal .= '<input type="hidden" id="cbListFilterCalendarFormat_'.$col.'" name="cb_filter_calendar_format['.$col.']" value="'.$format.'">';
                        }
                        else if(stripos($row, '@range/calendar/from') === 0){
                            $cal .= '<div class="cbListFilterCalendarWrapper">';
                            $cal .= '<input class="inputbox cbListFilterCalendar" id="cbListFilterCalendarFrom_'.$col.'" name="cbListFilterCalendarFrom['.$col.']" type="text" value="'.htmlentities($default_value_from, ENT_QUOTES, 'UTF-8').'"/>';
                            $cal .= '<button id="cbListFilterCalendarFrom_'.$col.'_button" class="button cbListFilterCalendarButton">'.JText::_('COM_CONTENTBUILDER_FROM2').'</button>';
                            $cal .= '</div>';
                            $cal .= '<script type="text/javascript">
                            <!--
                            Calendar.setup({
                                    inputField     :    "cbListFilterCalendarFrom_'.$col.'",
                                    button         :    "cbListFilterCalendarFrom_'.$col.'_button",
                                    ifFormat       :    "'.$format.'",
                                    align          :    "Bl",
                                    singleClick    :    true
                            });
                            contentbuilder_calendar_fields.push({from: "cbListFilterCalendarFrom_'.$col.'", to: "", col: "'.$col.'"});
                            //-->
                            </script>';
                            $cal .= '<input type="hidden" id="cbListFilterCalendarFormat_'.$col.'" name="cb_filter_calendar_format['.$col.']" value="'.$format.'">';
                        
                        } else if(stripos($row, '@range/calendar/to') === 0){
                            $cal .= '<div class="cbListFilterCalendarWrapper">';
                            $cal .= '<input class="inputbox cbListFilterCalendar" id="cbListFilterCalendarTo_'.$col.'" name="cbListFilterCalendarTo['.$col.']" type="text" value="'.htmlentities($default_value_to, ENT_QUOTES, 'UTF-8').'"/>';
                            $cal .= '<button id="cbListFilterCalendarTo_'.$col.'_button" class="button cbListFilterCalendarButton">'.JText::_('COM_CONTENTBUILDER_TO').'</button>';
                            $cal .= '</div>';
                            $cal .= '<script type="text/javascript">
                            <!--
                            Calendar.setup({
                                    inputField     :    "cbListFilterCalendarTo_'.$col.'",
                                    button         :    "cbListFilterCalendarTo_'.$col.'_button",
                                    ifFormat       :    "'.$format.'",
                                    align          :    "Bl",
                                    singleClick    :    true
                            });
                            contentbuilder_calendar_fields.push({from: "", to: "cbListFilterCalendarTo_'.$col.'", col: "'.$col.'"});
                            //-->
                            </script>';
                            $cal .= '<input type="hidden" id="cbListFilterCalendarFormat_'.$col.'" name="cb_filter_calendar_format['.$col.']" value="'.$format.'">';
                        }
                        
                        $fields[$col]['calendars'] .= $cal;
                        
                        if($cal){
                            $fields[$col]['calendars'] .= '<input type="hidden" id="cb_filter_'.$col.'" name="cb_filter['.$col.']" value=""/>';
                        }
                        
                        break;
                        
                    default:
                        
                        $has_options = true;
                        $label = $row;
                        
                        switch($label){
                            
                            case stripos($row, '@range/date/') === 0 || stripos($row, '@range/number/') === 0:
                                
                                $ex = explode('/', $row);
                                if (count($ex) == 3) {
                                    $ex2 = explode('to', trim($ex[2]));
                                    $out = '';
                                    $val = $ex2[0];
                                    $val2 = '';
                                    if (isset($ex2[1])) {
                                        $val2 = $ex2[1];
                                    }
                                    if (strtolower(trim($ex[1])) == 'date') {
                                        $val = JHTML::_('date', $ex2[0], JText::_('DATE_FORMAT_LC3'));
                                        if (isset($ex2[1])) {
                                            $val2 = JHTML::_('date', $ex2[1], JText::_('DATE_FORMAT_LC3'));
                                        }
                                    }
                                    if (count($ex2) == 2) {
                                        $out = (trim($ex2[0]) ? JText::_('COM_CONTENTBUILDER_FROM') . ' ' . trim($val) : '') . ' ' . JText::_('COM_CONTENTBUILDER_TO') . ' ' . trim($val2);
                                    } else if (count($ex2) > 0) {
                                        $out = JText::_('COM_CONTENTBUILDER_FROM2') . ' ' . trim($val);
                                    }
                                    if ($out) {
                                        $label = $out;
                                    }
                                }
                                break;
                                
                            case stripos($row, '@match/') === 0:
                                
                                $ex = explode('/', $row);
                                if(count($ex) == 2){
                                    $ex2 = explode(';', trim($ex[1]));
                                    $out = '';
                                    $size = count($ex2);
                                    $i = 0;
                                    foreach($ex2 As $val){
                                       if($i + 1 < $size){
                                           $out .= trim($val) . ' ' . JText::_('COM_CONTENTBUILDER_AND') . ' ';
                                       }else{
                                           $out .= trim($val);
                                       }
                                       $i++;
                                    }
                                    if($out){
                                        $label = $out;
                                    }
                                }
                                break;
                        }
                        
                        $compare_submitted = '';
                        $submitted = JFactory::getSession()->get('com_contentbuilder.filter.'.$form_id, array());
                        
                        foreach($submitted As $key => $submit){
                            if($key == $col){
                                $compare_submitted = $submit;
                                break;
                            }
                        }
                        
                        $fields[$col]['selects'] .= '<option value="'.htmlentities($row, ENT_QUOTES, 'UTF-8').'"'.($row == $compare_submitted ? ' selected="selected"' : '').'>'.htmlentities(str_replace(array('|',';'),', ',$label), ENT_QUOTES, 'UTF-8').'</option>';
                }
                
            }
            $fields[$col]['selects'] .= '</select></div>';
            
            if(!$has_options){
                $fields[$col]['selects'] = '';
            }
        }
        
        return $fields;
    }
    
    function renderSearch($fields, $params){
        $db = JFactory::getDBO();
        $form_id = $params->get('form_id', null);
        if(!$form_id) return '';
        
        $out = '
<script type="text/javascript">
<!--
var contentbuilder_calendar_fields = new Array();
function contentbuilder_add_calendar_values(){
    for( var i = 0; i < contentbuilder_calendar_fields.length; i++ ){
        if( contentbuilder_calendar_fields[i].from != "" && contentbuilder_calendar_fields[i].to != "" ){
            document.getElementById("cb_filter_"+contentbuilder_calendar_fields[i].col).value = "@range/date/" + document.getElementById(contentbuilder_calendar_fields[i].from).value + " to " + document.getElementById(contentbuilder_calendar_fields[i].to).value;
        }
        else
        if( contentbuilder_calendar_fields[i].from != "" && contentbuilder_calendar_fields[i].to == "" ){
            document.getElementById("cb_filter_"+contentbuilder_calendar_fields[i].col).value = "@range/date/" + document.getElementById(contentbuilder_calendar_fields[i].from).value;
        }
        else
        if( contentbuilder_calendar_fields[i].from == "" && contentbuilder_calendar_fields[i].to != "" ){
            document.getElementById("cb_filter_"+contentbuilder_calendar_fields[i].col).value = "@range/date/to " + document.getElementById(contentbuilder_calendar_fields[i].to).value;
        }
    }
}
//-->
</script>
';
        $out .= '<form onsubmit="contentbuilder_add_calendar_values();" action="'.JRoute::_('index.php?option=com_contentbuilder&controller=list&view=list&search_form_id='.$form_id.'&id='.$form_id.'&Itemid='.($params->get('force_menu_item_id',0) > 0 ? $params->get('force_menu_item_id',0) : JRequest::getInt('Itemid', 0) )).'" method="post">';
        
        if($params->get('cb_filter_keywords',0)){
            
            $filter_keywords = JFactory::getSession()->get('com_contentbuilder.filter_keywords.'.$form_id, '');
                        
            $out .= '<h3>'.JText::_('COM_CONTENTBUILDER_KEYWORDS').'</h3>';
            $out .= '<div class="cbListFilterKeywordsWrapper">';
            $out .= '<input class="inputbox cbListFilterKeywords" type="text" id="cbListFilterKeywords" name="cbListFilterKeywords" value="'.htmlentities($filter_keywords,ENT_QUOTES,'UTF-8').'"/>';
            $out .= '</div>';
        }
        
        if($params->get('cb_filter_article_categories',0)){
            
            $filter_cat = JFactory::getSession()->get('com_contentbuilder.filter_article_categories.'.$form_id, -1);
                        
            $out .= '<h3>'.JText::_('COM_CONTENTBUILDER_ARTICLE_CATEGORIES').'</h3>';
            $out .= '<div class="cbListFilterArticleCategoriesWrapper">';
            $out .= self::getCategories($filter_cat);
            $out .= '</div>';
        }
       
        $db->setQuery("Select `label`,`reference_id` From #__contentbuilder_elements Where form_id = " . intval($form_id));
        $labelrefs = $db->loadAssocList();
        
        if(trim($params->get('cb_drill','')) != ''){
            
            $out .= '<h3>'.JText::_('COM_CONTENTBUILDER_DRILL_TITLE').'</h3>';
            
            $field_ids = explode(',',str_replace(' ','',$params->get('cb_drill','')));
            
            // remember values and selections after page load
            $pre_selected = '';
            $load = '';
            
            $i = 0;
            foreach($field_ids As $field_id){
                
                $submitted = JFactory::getSession()->get('com_contentbuilder.filter.'.$form_id, array());

                foreach($submitted As $key => $submit){
                    $pre_selected .= 'cbPreSelected["'.$field_id.'"] = "'.addslashes($submit).'";'."\n";
                    if($key == $field_id){
                        if(isset($field_ids[$i+1])){
                            $load .= '_.X("'.(JURI::root(true) . (JFactory::getApplication()->isAdmin() ? '/administrator' : (JRequest::getCmd('lang','') && JFactory::getConfig()->getValue('config.sef') && JFactory::getConfig()->getValue('config.sef_rewrite') ? '/'.JRequest::getCmd('lang','') : '') ).'/?option=com_contentbuilder&lang='.JRequest::getCmd('lang','').'&controller=ajax&format=raw&subject=get_unique_values&id='.$form_id.'&field_reference_id='.$field_ids[$i+1]).'&where_field='.$field_id.'&where='.addslashes($submit).'", cbRetrieveDrillContent);'."\n";
                        }
                        break;
                    }
                }
                $i++;
            }
            
            $out .= '<script type="text/javascript">
            <!--
            var cbPreSelected = {};
            '.$pre_selected.'
            function cbRetrieveDrillContent(value){
                var result = json_decode(value);
                if(typeof result == "object"){
                    if(result["code"] == 0){
                        var select = document.getElementById("cb_filter_"+result["field_reference_id"]);
                        select.options.length = 0; // clear out existing items
                        select.options.add(new Option(" - '.addslashes(JText::_('COM_CONTENTBUILDER_CHOOSE')).' - ", ""));
                        for(var i=0; i < result["msg"].length; i++) {
                            var d = result["msg"][i];
                            if(d != ""){
                                select.options.add(new Option(d, d, false, typeof cbPreSelected[result["field_reference_id"]] != "undefined" && d == cbPreSelected[result["field_reference_id"]] ? true : false ));
                            }
                        }
                    }
                }
            }
            function cbLoadNextDrill(next_id, where_field, where){
                if(next_id != "-1"){
                    _.X("'.(JURI::root(true) . (JFactory::getApplication()->isAdmin() ? '/administrator' : (JRequest::getCmd('lang','') && JFactory::getConfig()->getValue('config.sef') && JFactory::getConfig()->getValue('config.sef_rewrite') ? '/'.JRequest::getCmd('lang','') : '') ).'/?option=com_contentbuilder&lang='.JRequest::getCmd('lang','').'&controller=ajax&format=raw&subject=get_unique_values&id='.$form_id.'&field_reference_id=').'"+next_id+"&where_field="+where_field+"&where="+where, cbRetrieveDrillContent);
                }
            }
            //-->
            </script>';
            
            $i = 0;
            foreach($field_ids As $field_id){
                foreach($labelrefs As $labelref){
                    if($labelref['reference_id'] == $field_id){
                        $out .= '<h3>'.htmlentities($labelref['label'], ENT_QUOTES, 'UTF-8').'</h3>';
                        $out .= '<div class="cbListFilterSelectWrapper"><select onchange="cbLoadNextDrill(\''.addslashes(isset($field_ids[$i+1]) ? $field_ids[$i+1] : -1).'\',\''.addslashes(isset($field_ids[$i]) ? $field_ids[$i] : -1).'\',this.options[this.selectedIndex].value);" id="cb_filter_'.$labelref['reference_id'].'" name="cb_filter['.$labelref['reference_id'].']" class="inputbox cbListFilterSelect chzn-done"></select></div>';
                        if( $i == 0 ){
                            $out .= '<script type="text/javascript">
                            <!--
                            _.X("'.(JURI::root(true) . (JFactory::getApplication()->isAdmin() ? '/administrator' : (JRequest::getCmd('lang','') && JFactory::getConfig()->getValue('config.sef') && JFactory::getConfig()->getValue('config.sef_rewrite') ? '/'.JRequest::getCmd('lang','') : '') ).'/?option=com_contentbuilder&lang='.JRequest::getCmd('lang','').'&controller=ajax&format=raw&subject=get_unique_values&id='.$form_id.'&field_reference_id='.$labelref['reference_id']).'", cbRetrieveDrillContent);
                            '.$load.'
                            //-->
                            </script>';
                        }
                        break;
                    }
                }
                $i++;
            }
        }
        
        foreach($labelrefs As $labelref){
            if(isset($fields[$labelref['reference_id']])){
                $out .= '<h3>'.htmlentities($labelref['label'], ENT_QUOTES, 'UTF-8').'</h3>';
                $out .= $fields[$labelref['reference_id']]['selects'];
                $out .= $fields[$labelref['reference_id']]['calendars'];
            }
        }
        
        $out .= '<button class="button cbListFilterSubmitButton">'.JText::_('COM_CONTENTBUILDER_SEARCH').'</button>';
        $out .= '<button onclick="document.getElementById(\'filter_reset\').value=\'1\';" class="button cbListFilterResetButton">'.JText::_('COM_CONTENTBUILDER_RESET').'</button>';
        $out .= '<div class="cbListFilterSubmitButtonAfter"></div>';
        
        $out .='
<input type="hidden" name="option" value="com_contentbuilder" />
<input type="hidden" name="task" id="task" value="" />
<input type="hidden" name="controller" id="controller" value="list" />
<input type="hidden" name="view" id="view" value="list" />
<input type="hidden" name="Itemid" value="'.($params->get('force_menu_item_id',0) > 0 ? $params->get('force_menu_item_id',0) : JRequest::getInt('Itemid', 0) ).'"/>
<input type="hidden" name="limitstart" value="" />
<input type="hidden" name="search_form_id" value="'.$form_id.'" />
<input type="hidden" name="filter_order" value="" />
<input type="hidden" name="filter_order_Dir" value="" />
<input type="hidden" id="filter_reset" name="filter_reset" value="0" />
<input type="hidden" name="contentbuilder_filter_signal" value="1" />  
';
        
        $out .= '</form>';
        
        return $out;
    }
    
    function getForm( $params )
    {
        $db = JFactory::getDBO();
        $form_id = $params->get('form_id', null);
        if(!$form_id) return;
        $db->setQuery("Select `type`,`reference_id` From #__contentbuilder_forms Where id = " . $db->Quote($form_id) . " And published = 1 And allow_external_filter = 1");
        $data = $db->loadAssoc();
        return contentbuilder::getForm($data['type'], $data['reference_id']);
    }
    
    
    // category retrieval
    
    function getCategories($filter_cat){
            jimport('joomla.version');
            $version = new JVersion();
            
            $options = new stdClass();
            
            $options->startcat = -1;
            
            if(!isset($options->level_reduce) || intval($options->level_reduce) < 0){
                $options->level_reduce = 1;
            }
            
            if(!isset($options->length)){
               $options->length = '';
            }
            
            $cats = array();
            
            if (version_compare($version->getShortVersion(), '1.6', '>=')) {
                jimport('joomla.application.categories');
                $categories = JCategories::getInstance('content');
                
                $show = $options->startcat;
                if($options->startcat == -1){
                    $show = 'root';
                    $options->level_reduce = 0;
                }
                $subCategories = $categories->get($show, false);
                
                if(is_object($subCategories)){
                   $subCategories = $subCategories->getChildren(true);
                   foreach($subCategories As $subCategory){
                      $cats[$subCategory->id] = str_repeat('-', $subCategory->level - intval($options->level_reduce)) . ' ' . htmlentities($subCategory->title, ENT_QUOTES, 'UTF-8');  
                   }
                }
            }else{
                $show = '';
                if($options->startcat > -1){
                    $show = ' And section = '.$options->startcat;
                }
                $db = JFactory::getDBO();
                $query = 'SELECT id, title' .
                                ' FROM #__categories' .
                                ' WHERE access <= '.intval(JFactory::getUser()->get('id')).' And published = 1 '.$show.
                                ' ORDER BY ordering';
                $db->setQuery($query);
                $cat_list = $db->loadObjectList();
                foreach($cat_list As $cat){
                    $cats[$cat->id] = htmlentities($cat->title, ENT_QUOTES, 'UTF-8');
                }
            }
            
            $the_item = '<select class="inputbox cbListFilterArticleCategories chzn-done" id="cbListFilterArticleCategories" name="cbListFilterArticleCategories" >';
            $the_item .= '<option value="-1"> - '.JText::_('COM_CONTENTBUILDER_CHOOSE').' - </option>';                 
            foreach($cats As $key => $value){
                $the_item .= '<option '.($filter_cat == intval($key) ? 'selected="selected" ' : '').'value="'.intval($key).'">'.$value.'</option>';
            }
            
            $the_item .= '</select>';
            
            return $the_item;
    }
    
}